#Copyright 2008 Alexander Exner

#This file is part of WebcamDemo.

#WebcamDemo is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#WebcamDemo is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with WebcamDemo.  If not, see <http://www.gnu.org/licenses/>.

import sys
import pygame
from pygame.locals import *
import Image
import ImageOps
import opencv
import opencv.highgui
import getimage
import performance
import matrixstuff

# Import Psyco if available
try:
    import psyco
    psyco.full()
except ImportError:
    pass

lastfps = 0
maxfps = 30
width = 640
height = 480
camera = opencv.highgui.cvCreateCameraCapture(0)
opencv.highgui.cvSetCaptureProperty(camera, opencv.highgui.CV_CAP_PROP_FRAME_WIDTH, width)
opencv.highgui.cvSetCaptureProperty(camera, opencv.highgui.CV_CAP_PROP_FRAME_HEIGHT, height)
#print highgui.cvGetCaptureProperty(camera, highgui.CV_CAP_PROP_FRAME_WIDTH)
#print highgui.cvGetCaptureProperty(camera, highgui.CV_CAP_PROP_FRAME_HEIGHT)
pygame.init()
window = pygame.display.set_mode((width, height))
pygame.display.set_caption("Detect Red 1")
screen = pygame.display.get_surface()

perf = performance.FpsControl(maxfps)
font = pygame.font.Font(None, 36)
#a new surface the size of our window, will serve as a bg
background = pygame.Surface(screen.get_size())
background = background.convert()
background.fill((250, 250, 250))

ux = width / 2
uy = height / 2
radius = 20
wm = matrixstuff.getWeightMatrix(radius)

while True:
    events = pygame.event.get()
    for event in events:
        if event.type == QUIT or event.type == KEYDOWN:
            sys.exit(0)
    img_PIL = ImageOps.mirror(getimage.get_image_PIL(camera))
    # clip image around the circle
    crop_PIL_split = img_PIL.crop((ux - radius, uy - radius, ux + radius + 1, uy + radius + 1)).split()
    test_matrix = matrixstuff.RsubGB(matrixstuff.imageToArray(crop_PIL_split[0]), matrixstuff.imageToArray(crop_PIL_split[1]), matrixstuff.imageToArray(crop_PIL_split[2]))
    #test_matrix *= wm
    (vx, vy) = matrixstuff.getVector(test_matrix)
    #print vx, vy
    if abs(vx) > 10:
        ux -= (vx / 4)
    if abs(vy) > 10:
        uy -= (vy / 4)

    background.blit(getimage.convert_PIL_to_pygame(img_PIL), (0, 0))
    #test_PIL0 = matrixstuff.arrayToImage(test_matrix)
    #test_PIL1 = Image.new("L", (radius * 2 + 1, radius * 2 + 1), (0))
    #test_PIL2 = Image.new("L", (radius * 2 + 1, radius * 2 + 1), (0))
    #test_PIL = Image.merge("RGB", (test_PIL0, test_PIL1, test_PIL2))
    #background.blit(getimage.convert_PIL_to_pygame(test_PIL), (ux - radius, uy - radius))
    pygame.draw.circle(background, (0, 255, 0), (ux, uy), 10, 3)
    screen.blit(background, (0, 0))
    screen.blit(font.render(str(lastfps), 1, (100, 100, 100)), (10, 10))
    pygame.display.flip()
    lastfps = perf.go()
