#Copyright 2008 Alexander Exner

#This file is part of WebcamDemo.

#WebcamDemo is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#WebcamDemo is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with WebcamDemo.  If not, see <http://www.gnu.org/licenses/>.

import pygame
import Image

import opencv
from opencv import highgui

def convert_PIL_to_pygame(image_PIL):
    return pygame.image.frombuffer(image_PIL.tostring(), image_PIL.size, image_PIL.mode)

def get_image_Ipl(camera):
    return highgui.cvQueryFrame(camera)

def get_image_PIL(camera):
    #convert Ipl image to PIL image
    return opencv.adaptors.Ipl2PIL(get_image_Ipl(camera))

def get_image_pygame(camera):
    return convert_PIL_to_pygame(get_image_PIL(camera))
